﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace GridControl
{
    public partial class Form1 : Form
    {
        private const string FROM_COLUMN_KEY = "SENDER_NAME";
        private const string SUBJECT_COLUMN_KEY = "MESSAGE_SUBJECT";
        private const string SIZE_COLUMN_KEY = "Size";
        private const string RECEIVED_COLUMN_KEY = "Received";
        private const string IMPORTANCE_LEVEL_COLUMN_KEY = "Importance";
        private const string ATTACHMENT_COLUMN_KEY = "Attachment";
        private const string MAIL_COLUMN_KEY = "MailIcon";

        private MessageHeaderInboxCollection _list = new MessageHeaderInboxCollection();

        private int _currentData = 1;

        public Form1()
        {
            InitializeComponent();
            //InitializeGrid();
            //PopulateCollection();
            //UiHelper.InitializeGridSettings(ultraGrid1);
            var messageHeadersControl = new ucMessageHeaders();
            messageHeadersControl.Dock = DockStyle.Fill;
            ultraPanel1.ClientArea.Controls.Add(messageHeadersControl);

            messageHeadersControl.SetDataSource();
        }

        //private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        //{
        //    e.Layout.Bands[0].Columns.Add(IMPORTANCE_LEVEL_COLUMN_KEY);
        //    e.Layout.Bands[0].Columns.Add(MAIL_COLUMN_KEY);
        //    e.Layout.Bands[0].Columns.Add(ATTACHMENT_COLUMN_KEY);
        //    e.Layout.Bands[0].Columns.Add(RECEIVED_COLUMN_KEY);
        //    e.Layout.Bands[0].Columns.Add(SIZE_COLUMN_KEY);

        //    //ultraGridMessages.DisplayLayout.Bands[0].Columns[ID_COLUMN_KEY].Hidden = true;
        //    SetColumnPosition(e.Layout.Bands[0].Columns);
        //    SetColumnAttributes(e.Layout.Bands[0].Columns);
        //    HideColumns(e.Layout.Bands[0].Columns);
        //}

        /// <summary>
        /// Sets the visible position of the columns that are shown.
        /// </summary>
        /// <param name="columns">Collection of column objects.</param>
        private void SetColumnPosition(ColumnsCollection columns)
        {
            columns[IMPORTANCE_LEVEL_COLUMN_KEY].Header.VisiblePosition = 0;
            columns[MAIL_COLUMN_KEY].Header.VisiblePosition = 1;
            columns[ATTACHMENT_COLUMN_KEY].Header.VisiblePosition = 2;
            columns[FROM_COLUMN_KEY].Header.VisiblePosition = 3;
            columns[SUBJECT_COLUMN_KEY].Header.VisiblePosition = 4;
            columns[RECEIVED_COLUMN_KEY].Header.VisiblePosition = 5;
            columns[SIZE_COLUMN_KEY].Header.VisiblePosition = 6;
        }

        /// <summary>
        /// Sets the column attributes of the columns that are shown.
        /// </summary>
        /// <param name="columns">Collection of column objects.</param>
        private void SetColumnAttributes(ColumnsCollection columns)
        {
            UiHelper.SetColumnAttributes(columns[IMPORTANCE_LEVEL_COLUMN_KEY], 20, SystemIcons.Asterisk.ToBitmap());
            UiHelper.SetColumnAttributes(columns[MAIL_COLUMN_KEY], 20, SystemIcons.Error.ToBitmap());
            UiHelper.SetColumnAttributes(columns[ATTACHMENT_COLUMN_KEY], 20, SystemIcons.Exclamation.ToBitmap());

            UiHelper.SetColumnAttributes(columns[SIZE_COLUMN_KEY], 35, HAlign.Right, "Size");
            UiHelper.SetColumnAttributes(columns[SUBJECT_COLUMN_KEY], 200, HAlign.Default, "Subject");
            UiHelper.SetColumnAttributes(columns[FROM_COLUMN_KEY], 120, HAlign.Default, "From");
            UiHelper.SetColumnAttributes(columns[RECEIVED_COLUMN_KEY], 65, HAlign.Right, "Received");
        }

        private void HideColumns(ColumnsCollection columns)
        {
            columns["MESSAGE_ID"].Hidden = true;
            columns["MESSAGE_IMPORTANCE_LEVEL"].Hidden = true;
            columns["SENDER_ID"].Hidden = true;
            columns["RESPOND_OPTION"].Hidden = true;
            columns["MARKED_UNREAD"].Hidden = true;
            columns["DATE_RECEIVED"].Hidden = true;
            columns["ATTACHMENTS_SIZE"].Hidden = true;
            columns["AlertDisplayed"].Hidden = true;
        }

        //private void InitializeLayoutDataSource()
        //{
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Id"].Hidden = true;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Header.VisiblePosition = 0;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Header.VisiblePosition = 1;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Header.VisiblePosition = 2;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Subject"].Header.VisiblePosition = 4;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Size"].Header.VisiblePosition = 6;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Size"].CellAppearance.TextHAlign = HAlign.Right;

        //    if (_currentData == 1)
        //    {
        //        //ultraGrid1.DisplayLayout.Bands[0].Columns["From"].Header.VisiblePosition = 3;
        //        //ultraGrid1.DisplayLayout.Bands[0].Columns["Received"].Header.VisiblePosition = 5;
        //        ultraGrid1.DisplayLayout.Bands[0].Columns["From"].Width = 100;
        //        ultraGrid1.DisplayLayout.Bands[0].Columns["Received"].Width = 100;
        //        ultraGrid1.DisplayLayout.Bands[0].Columns["Received"].CellAppearance.TextHAlign = HAlign.Right;

        //        ultraDataSource1.Band.Columns["Importance"].DataType = typeof(int);
        //        ultraDataSource1.Band.Columns["Mail"].DataType = typeof(bool);
        //        ultraDataSource1.Band.Columns["Attachment"].DataType = typeof(bool);
        //    }
        //    else
        //    {
        //        //ultraGrid1.DisplayLayout.Bands[0].Columns["To"].Header.VisiblePosition = 3;
        //        //ultraGrid1.DisplayLayout.Bands[0].Columns["Sent"].Header.VisiblePosition = 5;
        //        ultraGrid1.DisplayLayout.Bands[0].Columns["To"].Width = 100;
        //        ultraGrid1.DisplayLayout.Bands[0].Columns["Sent"].Width = 100;
        //        ultraGrid1.DisplayLayout.Bands[0].Columns["Sent"].CellAppearance.TextHAlign = HAlign.Right;
        //    }

        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Width = 20;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].LockedWidth = true;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].MinWidth = 20;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].MaxWidth = 20;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Width = 25;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].MinWidth = 25;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].MaxWidth = 25;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Width = 20;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].MinWidth = 20;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].MaxWidth = 20;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Subject"].Width = 400;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Size"].Width = 75;

        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Header.Caption = string.Empty;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Header.Appearance.Image =
        //        Images.GetImage(Images.IEImages.BD._24x24.Shadow.paperclip);

        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Header.Caption = string.Empty;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Header.Appearance.Image =
        //        Images.GetImage(Images.IEImages.OP._24x24.Shadow.flag_yellow);

        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Header.Caption = string.Empty;
        //    ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Header.Appearance.Image =
        //        Images.GetImage(Images.IEImages.AB._24x24.Shadow.document_plain);
        //}

        private void Form1_Load(object sender, EventArgs e)
        {
            //LoadData();
            //var messageHeadersControl = new ucMessageHeaders();
            //messageHeadersControl.Dock = DockStyle.Fill;
            //ultraPanel1.ClientArea.Controls.Add(messageHeadersControl);

            //messageHeadersControl.SetDataSource();
            //ultraGrid1.DataSource = null;
            //ultraGrid1.Layouts.Clear();
            //ultraGrid1.DataSource = _list;
        }

        //private void LoadData()
        //{
        //    for (int i = 0; i < 100; i++)
        //    {
        //        //var row = ultraGrid1.DisplayLayout.Bands[0].AddNew();
        //        //row.Cells["Id"].Value = Guid.NewGuid();
        //        //row.Cells["Importance"].Value = i;
        //        //row.Cells["Mail"].Value = false;
        //        //row.Cells["Attachment"].Value = true;
        //        //row.Cells["From"].Value = "Mickey Mouse" + i;
        //        //row.Cells["Subject"].Value = "Disney World";
        //        //row.Cells["Received"].Value = DateTime.Now;
        //        //row.Cells["Size"].Value = i * 10;
        //        var row = ultraDataSource1.Rows.Add();
        //        row.SetCellValue("Id", Guid.NewGuid());
        //        row.SetCellValue("Importance", i);
        //        row.SetCellValue("Mail", false);
        //        row.SetCellValue("Attachment", true);
        //        row.SetCellValue("From", "Mickey Mouse" + i);
        //        row.SetCellValue("Subject", "Disney World");
        //        row.SetCellValue("Received", DateTime.Now);
        //        row.SetCellValue("Size", i * 10);

        //        //UltraGridRow gridRow = ultraGrid1.Rows[row.Index];
        //        //gridRow.Appearance.FontData.Bold = DefaultableBoolean.True;
        //        //row["Size"] = i * 10;

        //    }
        //}

        //private void LoadData2()
        //{
        //    //ultraDataSource1.Band.Columns["From"].Key = "To";
        //    //ultraDataSource1.Band.Columns["Received"].Key = "Sent";
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["To"].Header.Caption = "Hello";

        //    for (int i = 0; i < 100; i++)
        //    {
        //        var row = ultraDataSource2.Rows.Add();
        //        var contact = new Contact {LastName = "Duck" + i, FirstName = "Donald"};

        //        row.Tag = contact;
        //        row.SetCellValue("Id", Guid.NewGuid());
        //        row.SetCellValue("Importance", i%2 == 0 ? SystemIcons.Asterisk.ToBitmap() : null);
        //        row.SetCellValue("Mail", i % 2 == 0);
        //        row.SetCellValue("Attachment", true);
        //        row.SetCellValue("To", string.Format("{0} {1}", contact.FirstName, contact.LastName));
        //        row.SetCellValue("Subject", "Disney World");
        //        row.SetCellValue("Sent", DateTime.Now);
        //        row.SetCellValue("Size", i * 10);
        //        //row["Size"] = i * 10;

        //    }
        //}

        //private void InitializeGrid()
        //{
        //    ultraGrid1.DisplayLayout.GroupByBox.Hidden = true;
        //    ultraGrid1.DisplayLayout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
        //    ultraGrid1.DisplayLayout.Override.HeaderAppearance.BackColor = Color.FromArgb(226, 238, 253);
        //    ultraGrid1.DisplayLayout.Override.HeaderAppearance.BackColor2 = Color.FromArgb(175, 210, 255);
        //    ultraGrid1.DisplayLayout.Override.HeaderAppearance.BackGradientStyle = GradientStyle.GlassTop50;
        //    ultraGrid1.DisplayLayout.Override.CellAppearance.TextTrimming = TextTrimming.EllipsisCharacter;

        //    ultraGrid1.DisplayLayout.Override.AllowColMoving = AllowColMoving.NotAllowed;
        //    ultraGrid1.DisplayLayout.Override.AllowUpdate = DefaultableBoolean.False;
        //    ultraGrid1.DisplayLayout.Override.AllowDelete = DefaultableBoolean.False;
        //    ultraGrid1.DisplayLayout.Override.SelectTypeRow = SelectType.Extended;
        //    ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.RowSelect;

        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Attachment", "Attachment");
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Importance", "Importance");
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Mail", "Mail");
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("From", "From");
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Subject", "Subject");
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Received", "Received");
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Size", "Size");

        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Header.VisiblePosition = 0;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Header.VisiblePosition = 1;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Header.VisiblePosition = 2;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["From"].Header.VisiblePosition = 3;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Subject"].Header.VisiblePosition = 4;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Received"].Header.VisiblePosition = 5;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Size"].Header.VisiblePosition = 6;

        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Width = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].LockedWidth = true;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].MinWidth = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].MaxWidth = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Width = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].MinWidth = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].MaxWidth = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Width = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].MinWidth = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].MaxWidth = 20;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["From"].Width = 100;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Subject"].Width = 400;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Received"].Width = 100;
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Size"].Width = 75;

        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].DataType = typeof(Image);
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Attachment"].Header.Appearance.Image =
        //    //    Images.GetImage(Images.IEImages.BD._24x24.Shadow.paperclip);
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].DataType = typeof(Image);
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Importance"].Header.Appearance.Image =
        //    //    Images.GetImage(Images.IEImages.OP._24x24.Shadow.flag_yellow);
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].DataType = typeof(Image);
        //    //ultraGrid1.DisplayLayout.Bands[0].Columns["Mail"].Header.Appearance.Image =
        //    //    Images.GetImage(Images.IEImages.AB._24x24.Shadow.document_plain);

        //}

        //private void ultraGrid1_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        //{
        //    //e.Row.CellAppearance.FontData.Bold = e.Row.CellAppearance.FontData.Bold == DefaultableBoolean.True ? DefaultableBoolean.False : DefaultableBoolean.True;
        //    //try
        //    //{
        //    //    var contact = ultraDataSource2.Rows[e.Row.Index].Tag as Contact;

        //    //    if (contact != null)
        //    //    {
        //    //        Console.WriteLine(string.Format("{0} {1}", contact.FirstName, contact.LastName));
        //    //    }
        //    //}
        //    //catch (Exception)
        //    //{
        //    //}
        //}

        //private void button1_Click(object sender, EventArgs e)
        //{
        //    if (_currentData == 1)
        //    {
        //        ultraDataSource1.Rows.Clear();
        //    }
        //    else
        //    {
        //        ultraDataSource2.Rows.Clear();
        //    }
        //}

        //private void button2_Click(object sender, EventArgs e)
        //{
        //    if (_currentData == 1)
        //    {
        //        ultraDataSource1.Rows.Clear();
        //        ultraGrid1.DataSource = null;
        //        ultraGrid1.Layouts.Clear();
        //        ultraGrid1.DataSource = ultraDataSource1;
        //        LoadData();
        //        _currentData = 2;
        //    }
        //    else
        //    {
        //        ultraDataSource2.Rows.Clear();
        //        ultraGrid1.DataSource = null;
        //        ultraGrid1.Layouts.Clear();
        //        ultraGrid1.DataSource = ultraDataSource2;
        //        LoadData2();
        //        _currentData = 1;
        //    }
        //}

        //private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        //{
        //    //if ((bool)e.Row.Cells["Mail"].Value)
        //    //{
        //    //    e.Row.CellAppearance.FontData.Bold = DefaultableBoolean.True;

        //    //}
        //    e.Row.Cells[IMPORTANCE_LEVEL_COLUMN_KEY].Value =
        //        GetMessageImportanceLevelImage((int)e.Row.Cells["MESSAGE_IMPORTANCE_LEVEL"].Value);

        //    int respondOption = (int)e.Row.Cells["RESPOND_OPTION"].Value;
        //    bool markedUnread = (bool)e.Row.Cells["MARKED_UNREAD"].Value;
        //    e.Row.Cells[MAIL_COLUMN_KEY].Value = GetMailImage((int)e.Row.Cells["RESPOND_OPTION"].Value, (bool)e.Row.Cells["MARKED_UNREAD"].Value);


        //    e.Row.Cells[ATTACHMENT_COLUMN_KEY].Value = GetAttachmentsImage((long)e.Row.Cells["ATTACHMENTS_SIZE"].Value > 0);

        //    if (e.Row.Cells["DATE_RECEIVED"].Value != null)
        //    {
        //        e.Row.Cells[RECEIVED_COLUMN_KEY].Value = ((DateTime)e.Row.Cells["DATE_RECEIVED"].Value).ToLongTimeString();
        //    }

        //    e.Row.Cells[SIZE_COLUMN_KEY].Value = FormatHelper.FormatBytes((long)e.Row.Cells["ATTACHMENTS_SIZE"].Value);
        //    e.Row.CellAppearance.FontData.Bold = (bool)e.Row.Cells["MARKED_UNREAD"].Value ? DefaultableBoolean.True : DefaultableBoolean.False;
        //}

        private Bitmap GetMailImage(int respondOption, bool isUnread)
        {
            Bitmap image = null;

            switch (respondOption)
            {
                case RespondOption.NONE:
                    if (isUnread)
                    {
                        // TODO: Need to replace with a different image
                        image = SystemIcons.Asterisk.ToBitmap();
                    }
                    else
                    {
                        image = SystemIcons.Asterisk.ToBitmap();
                    }
                    break;

                case RespondOption.REPLY:
                    break;

                case RespondOption.REPLY_ALL:
                    break;

                case RespondOption.FORWARD:
                    break;

                default:
                    // Let it default to None, but log it as a warning
                    image = SystemIcons.Asterisk.ToBitmap();
                    break;
            }

            return image;
        }

        /// <summary>
        /// Gets the image for the message importance level column.
        /// </summary>
        /// <param name="importanceLevel">The importance level of the message.</param>
        /// <returns>The image to display or null.</returns>
        private Bitmap GetMessageImportanceLevelImage(int importanceLevel)
        {
            Bitmap image = null;

            switch (importanceLevel)
            {
                case MessageImportanceLevel.LOW:
                    image = SystemIcons.Asterisk.ToBitmap();
                    break;

                case MessageImportanceLevel.NORMAL:
                    break;

                case MessageImportanceLevel.HIGH:
                    image = SystemIcons.Asterisk.ToBitmap();
                    break;

                default:
                    break;
            }

            return image;
        }

        /// <summary>
        /// Gets the image of the row if the message has attachments.
        /// </summary>
        /// <param name="hasAttachments">Flag indicating whether the message has attachments.</param>
        /// <returns>The image to display or null.</returns>
        private Bitmap GetAttachmentsImage(bool hasAttachments)
        {
            Bitmap image = null;

            if (hasAttachments)
            {
                image = SystemIcons.Asterisk.ToBitmap();
            }

            return image;
        }

        private void PopulateCollection()
        {
            var msg = new MessageHeaderInbox();

            msg.MessageId = Guid.NewGuid();
            msg.MessageImportanceLevel = 1;
            msg.AttachmentsSize = 0;
            msg.DateReceived = DateTime.UtcNow;
            msg.MarkedUnread = false;
            msg.MessageSubject = "message #1";
            msg.RespondOption = 0;
            msg.SenderName = "Goofy 1";
            _list.Add(msg);

            msg = new MessageHeaderInbox();
            msg.MessageId = Guid.NewGuid();
            msg.MessageImportanceLevel = 2;
            msg.AttachmentsSize = 4096;
            msg.DateReceived = DateTime.UtcNow;
            msg.MarkedUnread = true;
            msg.MessageSubject = "message #2";
            msg.RespondOption = 0;
            msg.SenderName = "Goofy 2";
            _list.Add(msg);

            msg = new MessageHeaderInbox();
            msg.MessageId = Guid.NewGuid();
            msg.MessageImportanceLevel = 3;
            msg.AttachmentsSize = 0;
            msg.DateReceived = DateTime.UtcNow;
            msg.MarkedUnread = true;
            msg.MessageSubject = "message #3";
            msg.RespondOption = 0;
            msg.SenderName = "Goofy 3";
            _list.Add(msg);

            msg = new MessageHeaderInbox();
            msg.MessageId = Guid.NewGuid();
            msg.MessageImportanceLevel = 1;
            msg.AttachmentsSize = 4096;
            msg.DateReceived = DateTime.UtcNow;
            msg.MarkedUnread = false;
            msg.MessageSubject = "message #4";
            msg.RespondOption = 0;
            msg.SenderName = "Goofy 4";
            _list.Add(msg);

            msg = new MessageHeaderInbox();
            msg.MessageId = Guid.NewGuid();
            msg.MessageImportanceLevel = 2;
            msg.AttachmentsSize = 0;
            msg.DateReceived = DateTime.UtcNow;
            msg.MarkedUnread = false;
            msg.MessageSubject = "message #5";
            msg.RespondOption = 0;
            msg.SenderName = "Goofy 5";
            _list.Add(msg);


        }
    }
}
